(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("React"), require("mobx"), require("mobxReact"));
	else if(typeof define === 'function' && define.amd)
		define(["React", "mobx", "mobxReact"], factory);
	else if(typeof exports === 'object')
		exports["react-form-mobx"] = factory(require("React"), require("mobx"), require("mobxReact"));
	else
		root["react-form-mobx"] = factory(root["React"], root["mobx"], root["mobxReact"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE__2__, __WEBPACK_EXTERNAL_MODULE__3__, __WEBPACK_EXTERNAL_MODULE__4__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 10);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

/**
 * Copyright 2013-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

if (false) { var throwOnDirectAccess, isValidElement, REACT_ELEMENT_TYPE; } else {
  // By explicitly using `prop-types` you are opting into new production behavior.
  // http://fb.me/prop-types-in-prod
  module.exports = __webpack_require__(20)();
}


/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "l", function() { return noop; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "g", function() { return isFunction; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "h", function() { return isNativeArray; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return isArray; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return isEmpty; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "k", function() { return isString; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return isDate; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "i", function() { return isObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "j", function() { return isPlainObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return clone; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return createId; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "o", function() { return warn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "m", function() { return padEnd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "n", function() { return padStart; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return filtersFlow; });
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(3);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(mobx__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var warning__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(9);
/* harmony import */ var warning__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(warning__WEBPACK_IMPORTED_MODULE_1__);
var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };




var uniqueId = 0;

var pad = function pad(target, length, fillString, calc) {
	var prev = target.toString();
	while (prev.length < length) {
		prev = calc(prev);
	}return prev;
};

var noop = function noop() {};

var isFunction = function isFunction(s) {
	return typeof s === 'function';
};
var isNativeArray = function isNativeArray(s) {
	return s && s.constructor === Array;
};
var isArray = function isArray(s) {
	return isNativeArray(s) || Object(mobx__WEBPACK_IMPORTED_MODULE_0__["isObservableArray"])(s);
};
var isEmpty = function isEmpty(s) {
	return !s && s !== false && s !== 0;
};
var isString = function isString(s) {
	return typeof s === 'string';
};
var isDate = function isDate(s) {
	return s && s.constructor === Date;
};
var isObject = function isObject(s) {
	return (typeof s === 'undefined' ? 'undefined' : _typeof(s)) === 'object';
};
var isPlainObject = function isPlainObject(s) {
	return !!s && isObject(s) && !isDate(s);
};

var clone = function clone(s) {
	if (isArray(s)) return s.slice();
	if (isObject(s)) return _extends({}, s);
	return s;
};

var createId = function createId(key) {
	return key + '[' + uniqueId++ + ']';
};

var warn = function warn() {
	for (var _len = arguments.length, msgs = Array(_len), _key = 0; _key < _len; _key++) {
		msgs[_key] = arguments[_key];
	}

	return warning__WEBPACK_IMPORTED_MODULE_1___default()(false, '[react-form-mobx] ' + msgs.join(' '));
};

var padEnd = function padEnd(target, length, fillString) {
	return pad(target, length, fillString, function (prev) {
		return '' + prev + fillString;
	});
};

var padStart = function padStart(target, length, fillString) {
	return pad(target, length, fillString, function (prev) {
		return '' + fillString + prev;
	});
};

var filtersFlow = function filtersFlow(filters, value, options) {
	filters = filters.filter(Boolean);
	var next = function next(value, options) {
		if (!filters.length) return value;
		var filter = filters.shift();
		return next(filter(value, options), options);
	};
	return next(value, options);
};

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__2__;

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__3__;

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__4__;

/***/ }),
/* 5 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return formatHelper; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FormatTypesKeys; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return createFormatFunc; });
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1);


var ensureDate = function ensureDate(date) {
	if (Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* isDate */ "e"])(date)) return date;
	if (Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* isObject */ "i"])(date)) {
		// for moment() like object
		if (Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* isFunction */ "g"])(date.toDate)) return date.toDate();

		// for luxon.DateTime
		if (Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* isFunction */ "g"])(date.toJSDate)) return date.toJSDate();
	}
	if (/^\d+$/.test(date)) return new Date(+Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* padEnd */ "m"])(date, 13, '0'));
	return new Date(date);
};

var validNumber = function validNumber(val) {
	if (!/^-?\d+\.?\d*$/.test(val)) {
		throw new Error(val + ' is NOT a valid "number" type');
	}
	return true;
};

var toNumber = function toNumber(val) {
	return validNumber(val) && (+val || 0);
};
var toInt = function toInt(val) {
	return ~~toNumber(val);
};

var toStr = function toStr(val) {
	return val.toString();
};
var toBoolean = function toBoolean(val) {
	return !!val && val !== '0' && val !== 'false' && val !== 'undefined' && val !== 'null';
};

var toDateTime = function toDateTime(val) {
	// handle multi dateTime string by "," seperator
	if (Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* isString */ "k"])(val) && ~val.indexOf(',')) {
		return val.split(',').map(toDateTime).join(',');
	}

	try {
		return toDate(val) + 'T' + toTime(val);
	} catch (err) {
		throw new Error('Can NOT convert "' + val + '" to "dateTime" format');
	}
};

var toDate = function toDate(val) {
	// handle multi date string by "," seperator
	if (Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* isString */ "k"])(val) && ~val.indexOf(',')) {
		return val.split(',').map(toDate).join(',');
	}

	try {
		var d = ensureDate(val);
		if (d.toString() === 'Invalid Date') throw new Error();
		var year = d.getFullYear();
		var month = Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* padStart */ "n"])(d.getMonth() + 1, 2, 0);
		var date = Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* padStart */ "n"])(d.getDate(), 2, 0);
		return year + '-' + month + '-' + date;
	} catch (err) {
		throw new Error('Can NOT convert "' + val + '" to "date" format');
	}
};

var toTime = function toTime(val) {
	// handle multi time string by "," seperator
	if (Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* isString */ "k"])(val) && ~val.indexOf(',')) {
		return val.split(',').map(toTime).join(',');
	}

	try {
		var d = ensureDate(val);
		if (d.toString() === 'Invalid Date') throw new Error();
		var hours = Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* padStart */ "n"])(d.getHours(), 2, 0);
		var minutes = Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* padStart */ "n"])(d.getMinutes(), 2, 0);
		var seconds = Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* padStart */ "n"])(d.getSeconds(), 2, 0);
		var partialTime = hours + ':' + minutes + ':' + seconds;
		var zoneOffset = -d.getTimezoneOffset();

		/* istanbul ignore next */
		var offsetDif = zoneOffset < 0 ? '-' : '+';

		var offsetZoneHours = Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* padStart */ "n"])(Math.abs(zoneOffset / 60), 2, 0);
		var offsetZoneMinutes = Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* padStart */ "n"])(Math.abs(zoneOffset % 60), 2, 0);
		var offset = '' + offsetDif + offsetZoneHours + ':' + offsetZoneMinutes;
		return partialTime + offset;
	} catch (err) {
		throw new Error('Can NOT convert "' + val + '" to "time" format');
	}
};

var formatHelper = {
	integer: toInt,
	number: toNumber,
	string: toStr,
	boolean: toBoolean,
	date: toDate,
	time: toTime,
	dateTime: toDateTime
};

var FormatTypesKeys = Object.keys(formatHelper);

// TODO: add cache
function createFormatFunc(type) {
	return function format(val) {
		if (Object(_utils__WEBPACK_IMPORTED_MODULE_0__[/* isEmpty */ "f"])(val)) return val;
		return formatHelper[type](val);
	};
}

/***/ }),
/* 6 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(process) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ObjectStore; });
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(3);
/* harmony import */ var mobx__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(mobx__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _PrimitiveStore__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7);
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(1);
var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}





var ObjectStore = (_class = function (_PrimitiveStore) {
	_inherits(ObjectStore, _PrimitiveStore);

	function ObjectStore(pristineValue, options) {
		_classCallCheck(this, ObjectStore);

		var _this = _possibleConstructorReturn(this, (ObjectStore.__proto__ || Object.getPrototypeOf(ObjectStore)).call(this, pristineValue, options));

		_this.change = function (store) {
			if (!Object(_utils__WEBPACK_IMPORTED_MODULE_2__[/* isFunction */ "g"])(_this.bus.change)) return;
			var ev = {};
			var defineProperty = function defineProperty(prop, get) {
				Object.defineProperty(ev, prop, {
					enumerable: true,
					configurable: true,
					get: get
				});
			};
			defineProperty('value', function () {
				return _this.value;
			});
			defineProperty('key', function () {
				return store.key;
			});
			_this.bus.change(ev);
			process.nextTick(function () {
				delete ev.value;
				delete ev.key;
			});
		};

		_this.children = mobx__WEBPACK_IMPORTED_MODULE_0__["observable"].map();
		_this.bus.change = options.onChange;
		return _this;
	}

	_createClass(ObjectStore, [{
		key: 'getDefaultStoreValue',
		value: function getDefaultStoreValue() {
			return {};
		}
	}, {
		key: 'applyGetValue',
		value: function applyGetValue() {
			var res = this.getDefaultStoreValue();
			this.eachChildren(function (child, key) {
				res[key] = child.value;
			});
			return res;
		}
	}, {
		key: 'applySetValue',
		value: function applySetValue(value) {
			this.eachChildren(function (child, key) {
				child.value = value[key];
			});
		}
	}, {
		key: 'applySetPristineValue',
		value: function applySetPristineValue() {
			var _this2 = this;

			this.isChecked = false;
			this.eachChildren(function (child, key) {
				var val = _this2.sourceValue[key];
				child.pristineValue = val;
			});
		}
	}, {
		key: 'applyGetErrorMessage',
		value: function applyGetErrorMessage() {
			var errorMessage = '';
			this.eachChildren(function (child) {
				if (!errorMessage) errorMessage = child.errorMessage;
			});
			return errorMessage;
		}
	}, {
		key: 'getFormData',
		value: function getFormData() {
			var res = this.getDefaultStoreValue();
			this.eachChildren(function (child, key) {
				var val = child.getFormData();
				if (!child.shouldIgnore(val)) res[key] = val;
			});
			var value = this.getOutputValue(res);
			return this.shouldIgnore(value) ? undefined : value;
		}
	}, {
		key: 'eachChildren',
		value: function eachChildren(iterator) {
			var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
			var _options$checked = options.checked,
			    checked = _options$checked === undefined ? true : _options$checked;
			var _iteratorNormalCompletion = true;
			var _didIteratorError = false;
			var _iteratorError = undefined;

			try {
				for (var _iterator = this.children[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
					var _step$value = _slicedToArray(_step.value, 2),
					    key = _step$value[0],
					    item = _step$value[1];

					if (!checked || item.isChecked) {
						iterator(item, key, this.children);
					}
				}
			} catch (err) {
				_didIteratorError = true;
				_iteratorError = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion && _iterator.return) {
						_iterator.return();
					}
				} finally {
					if (_didIteratorError) {
						throw _iteratorError;
					}
				}
			}
		}
	}, {
		key: 'shouldCheck',
		value: function shouldCheck(key, value) {
			var val = this.sourceValue[key];
			var checked = val === value;
			if (checked) return checked;
			if (value === true) return val === 'true';
			return false;
		}
	}, {
		key: 'hasKey',
		value: function hasKey(key) {
			return this.sourceValue.hasOwnProperty(key);
		}
	}, {
		key: 'getChildren',
		value: function getChildren(key) {
			var children = this.children;

			if (children.has(key)) return children.get(key);
		}
	}, {
		key: 'setChildren',
		value: function setChildren(key, store) {
			this.children.set(key, store);
			return true;
		}
	}, {
		key: 'touch',
		value: function touch(isTouched) {
			this.eachChildren(function (child) {
				return child.touch(isTouched);
			});
		}
	}, {
		key: 'attach',
		value: function attach(key, options) {
			var sourceValue = this.sourceValue,
			    form = this.form;

			var val = sourceValue[key];
			return form.createChildren(this, key, val, options);
		}
	}, {
		key: 'detach',
		value: function detach(key) {
			this.children.delete(key);
		}
	}]);

	return ObjectStore;
}(_PrimitiveStore__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"]), (_applyDecoratedDescriptor(_class.prototype, 'applySetValue', [mobx__WEBPACK_IMPORTED_MODULE_0__["action"]], Object.getOwnPropertyDescriptor(_class.prototype, 'applySetValue'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'applySetPristineValue', [mobx__WEBPACK_IMPORTED_MODULE_0__["action"]], Object.getOwnPropertyDescriptor(_class.prototype, 'applySetPristineValue'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'touch', [mobx__WEBPACK_IMPORTED_MODULE_0__["action"]], Object.getOwnPropertyDescriptor(_class.prototype, 'touch'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'attach', [mobx__WEBPACK_IMPORTED_MODULE_0__["action"]], Object.getOwnPropertyDescriptor(_class.prototype, 'attach'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'detach', [mobx__WEBPACK_IMPORTED_MODULE_0__["action"]], Object.getOwnPropertyDescriptor(_class.prototype, 'detach'), _class.prototype)), _class);

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(11)))

/***/ }),
/* 7 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXTERNAL MODULE: ./src/FormatTypes.js
var FormatTypes = __webpack_require__(5);

// EXTERNAL MODULE: ./src/utils.js
var utils = __webpack_require__(1);

// CONCATENATED MODULE: ./src/Validation.js
var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }



var throwIfNot = function throwIfNot(isValid, errorMessage) {
	if (isValid) return true;
	throw new Error(errorMessage);
};

var Validation_Validation = function () {
	_createClass(Validation, null, [{
		key: 'enum',
		value: function _enum(list) {
			return function validateByEnum(val) {
				var whiteList = list.map(function (str) {
					return '"' + str + '"';
				}).join(', ');
				return throwIfNot(~list.indexOf(val), 'Expect one of ' + whiteList + ', but received "' + val + '"');
			};
		}
	}, {
		key: 'pattern',
		value: function pattern(regexp) {
			return function validateByPattern(val) {
				return throwIfNot(regexp.test(val), '"' + val + '" did NOT match pattern "' + regexp + '"');
			};
		}
	}, {
		key: 'maxLength',
		value: function maxLength(max) {
			return function validateByMaxLength(val) {
				return throwIfNot(max > val.toString().length, 'Expect max length is "' + max + '", but received "' + val + '"');
			};
		}
	}, {
		key: 'minLength',
		value: function minLength(min) {
			return function validateByMinLength(val) {
				return throwIfNot(min < val.toString().length, 'Expect min length is "' + min + '", but received "' + val + '"');
			};
		}
	}, {
		key: 'maximum',
		value: function maximum(max) {
			return function validateByMaximum(val) {
				return throwIfNot(max >= +val,

				/* eslint-disable-next-line max-len */
				'Expect strictly less than or exactly equal "' + max + '", but received "' + val + '"');
			};
		}
	}, {
		key: 'exclusiveMaximum',
		value: function exclusiveMaximum(max) {
			return function validateByExclusiveMaximum(val) {
				return throwIfNot(max > +val,

				/* eslint-disable-next-line max-len */
				'Expect strictly less than (not equal to) "' + max + '", but received "' + val + '"');
			};
		}
	}, {
		key: 'minimum',
		value: function minimum(min) {
			return function validateByMinimum(val) {
				return throwIfNot(min <= +val,

				/* eslint-disable-next-line max-len */
				'Expect strictly greater than or exactly equal "' + min + '", but received "' + val + '"');
			};
		}
	}, {
		key: 'exclusiveMinimum',
		value: function exclusiveMinimum(min) {
			return function validateByExclusiveMinimum(val) {
				return throwIfNot(min < +val,

				/* eslint-disable-next-line max-len */
				'Expect strictly greater than (not equal to) "' + min + '", but received "' + val + '"');
			};
		}
	}]);

	function Validation(options) {
		_classCallCheck(this, Validation);

		var preValidate = options.preValidate,
		    rules = options.validation,
		    required = options.required,
		    enumeration = options.enum,
		    pattern = options.pattern,
		    maxLength = options.maxLength,
		    minLength = options.minLength,
		    maximum = options.maximum,
		    exclusiveMaximum = options.exclusiveMaximum,
		    minimum = options.minimum,
		    exclusiveMinimum = options.exclusiveMinimum,
		    preFormat = options.preFormat,
		    formatFilter = options.formatFilter;

		this.required = required;
		this._rules = [].concat(rules).filter(Boolean);
		this._preValidate = preValidate;

		if (enumeration) this._rules.push(Validation.enum(enumeration));
		if (pattern) this._rules.push(Validation.pattern(pattern));
		if (maxLength) this._rules.push(Validation.maxLength(maxLength));
		if (minLength) this._rules.push(Validation.minLength(minLength));
		if (maximum) this._rules.push(Validation.maximum(maximum));
		if (exclusiveMaximum) {
			this._rules.push(Validation.exclusiveMaximum(exclusiveMaximum));
		}
		if (minimum) this._rules.push(Validation.minimum(minimum));
		if (exclusiveMinimum) {
			this._rules.push(Validation.exclusiveMinimum(exclusiveMinimum));
		}

		if (formatFilter) {
			var formatFilterValidator = function formatFilterValidator(val) {
				val = preFormat ? preFormat(val) : val;
				formatFilter(val);
				return true;
			};
			this._rules.push(formatFilterValidator);
		}
	}

	_createClass(Validation, [{
		key: 'exec',
		value: function exec(value) {
			var _rules = this._rules,
			    _preValidate = this._preValidate;
			var length = _rules.length;


			if (Object(utils["f" /* isEmpty */])(value)) {
				if (this.required) throw new Error('Required');
				return;
			}

			if (_preValidate) value = _preValidate(value);

			for (var index = 0; index < length; index++) {
				var rule = _rules[index];
				var isValid = rule(value);
				if (!isValid) {
					throw new Error('Invalid');
				}
			}
		}
	}]);

	return Validation;
}();


// EXTERNAL MODULE: external "mobx"
var external_mobx_ = __webpack_require__(3);

// CONCATENATED MODULE: ./src/FormStore/PrimitiveStore.js
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PrimitiveStore_PrimitiveStore; });
var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var PrimitiveStore_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _desc2, _value2, _class3, _descriptor6;

function _initDefineProp(target, property, descriptor, context) {
	if (!descriptor) return;
	Object.defineProperty(target, property, {
		enumerable: descriptor.enumerable,
		configurable: descriptor.configurable,
		writable: descriptor.writable,
		value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
	});
}

function PrimitiveStore_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}

function _initializerWarningHelper(descriptor, context) {
	throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}






var Actual = (_class = function () {
	function Actual() {
		PrimitiveStore_classCallCheck(this, Actual);

		_initDefineProp(this, 'pristineValue', _descriptor, this);

		_initDefineProp(this, 'value', _descriptor2, this);

		_initDefineProp(this, 'sourceValue', _descriptor3, this);

		_initDefineProp(this, 'errorMessage', _descriptor4, this);

		_initDefineProp(this, 'checkedStatus', _descriptor5, this);
	}

	/**
  * checked status
  *
  * `-1`: user unchecked, should be `false` as usual
  * `0` : default status, should be `undefined` as usual
  * `1` : user checked, should be `true` as usual
  */


	PrimitiveStore_createClass(Actual, [{
		key: 'setInitialValue',
		value: function setInitialValue(initialValue) {
			this.pristineValue = initialValue;
			this.sourceValue = initialValue;
			this.value = initialValue;
		}
	}]);

	return Actual;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'pristineValue', [external_mobx_["observable"]], {
	enumerable: true,
	initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'value', [external_mobx_["observable"]], {
	enumerable: true,
	initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'sourceValue', [external_mobx_["observable"]], {
	enumerable: true,
	initializer: null
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'errorMessage', [external_mobx_["observable"]], {
	enumerable: true,
	initializer: function initializer() {
		return '';
	}
}), _descriptor5 = _applyDecoratedDescriptor(_class.prototype, 'checkedStatus', [external_mobx_["observable"]], {
	enumerable: true,
	initializer: function initializer() {
		return 0;
	}
})), _class);
var PrimitiveStore_PrimitiveStore = (_class3 = function () {
	PrimitiveStore_createClass(PrimitiveStore, [{
		key: 'pristineValue',
		get: function get() {
			var pristineValue = this._actual.pristineValue,
			    isPristineValueEmpty = this.isPristineValueEmpty;

			return isPristineValueEmpty ? this.getDefaultStoreValue() : pristineValue;
		},
		set: function set(value) {
			var finalValue = this.getInputValue(value);
			this._actual.checkedStatus = 0;
			this._actual.pristineValue = finalValue;
			this.sourceValue = finalValue;
			if (this.applySetPristineValue) this.applySetPristineValue(finalValue);
			this._actual.value = finalValue;
			if (this.applySetValue) this.applySetValue(this.value);
			this.validate();
			return true;
		}
	}, {
		key: 'sourceValue',
		get: function get() {
			var sourceValue = this._actual.sourceValue,
			    isSourceValueEmpty = this.isSourceValueEmpty;

			return isSourceValueEmpty ? this.getDefaultStoreValue() : sourceValue;
		},
		set: function set(value) {
			this._actual.sourceValue = Object(utils["a" /* clone */])(value);
			return true;
		}
	}, {
		key: 'value',
		get: function get() {
			var value = this.applyGetValue();
			if (Object(external_mobx_["isObservableArray"])(value) && !Object(utils["h" /* isNativeArray */])(value)) return value.slice();
			return value;
		},
		set: function set(value) {
			this._actual.value = value;
			if (this.applySetValue) this.applySetValue(value);
			return true;
		}
	}, {
		key: 'errorMessage',
		get: function get() {
			var errorMessage = this._actual.errorMessage;

			var childErrorMessage = this.applyGetErrorMessage && this.applyGetErrorMessage();
			if (errorMessage) return errorMessage;
			return childErrorMessage || '';
		},
		set: function set(errorMessage) {
			this._actual.errorMessage = errorMessage;
			return true;
		}
	}, {
		key: 'isChecked',
		get: function get() {
			if (!this._checkable) return true;
			var _options = this._options,
			    parentStore = this.parentStore,
			    key = this.key,
			    value = this.value,
			    checkedStatus = this._actual.checkedStatus;

			var shouldChecked = parentStore.shouldCheck(key, value);
			if (checkedStatus) return checkedStatus > 0;
			if (parentStore.hasKey(key)) return shouldChecked;
			return _options.hasOwnProperty('defaultChecked') ? _options.defaultChecked : shouldChecked;
		},
		set: function set(checked) {
			/* istanbul ignore next */
			if (!this._checkable) return true;

			this._actual.checkedStatus = checked ? 1 : -1;
			return true;
		}
	}, {
		key: 'isPristineValueEmpty',
		get: function get() {
			return Object(utils["f" /* isEmpty */])(this._actual.pristineValue);
		}
	}, {
		key: 'isSourceValueEmpty',
		get: function get() {
			return Object(utils["f" /* isEmpty */])(this._actual.sourceValue);
		}
	}, {
		key: 'isValueEmpty',
		get: function get() {
			return Object(utils["f" /* isEmpty */])(this._actual.value);
		}
	}, {
		key: 'isValid',
		get: function get() {
			return !this.errorMessage;
		}
	}, {
		key: 'isInvalid',
		get: function get() {
			return !this.isValid;
		}
	}]);

	function PrimitiveStore(pristineValue, options) {
		var _this = this;

		PrimitiveStore_classCallCheck(this, PrimitiveStore);

		_initDefineProp(this, 'isTouched', _descriptor6, this);

		this._defaultValueFilter = function (value) {
			var _options = _this._options;

			if (_options.hasOwnProperty('defaultValue') && Object(utils["f" /* isEmpty */])(value)) {
				return _options.defaultValue;
			}
			return value;
		};

		this.submit = function () {
			var _form;

			return (_form = _this.form).submit.apply(_form, arguments);
		};

		this.reset = function () {
			var _form2;

			return (_form2 = _this.form).reset.apply(_form2, arguments);
		};

		this.clear = function () {
			var _form3;

			return (_form3 = _this.form).clear.apply(_form3, arguments);
		};

		var key = options.key,
		    parentStore = options.parentStore,
		    checkable = options.checkable,
		    isRadio = options.isRadio,
		    _options$form = options.form,
		    form = _options$form === undefined ? this : _options$form,
		    preFormat = options.preFormat,
		    format = options.format,
		    formatFunc = options.formatFunc,
		    inputFilter = options.inputFilter,
		    outputFilter = options.outputFilter,
		    enforceSubmit = options.enforceSubmit;

		var formatFilter = formatFunc || format && Object(FormatTypes["b" /* createFormatFunc */])(format);
		this.key = key;
		this.form = form;
		this.parentStore = parentStore;
		this._options = options;
		this.isRadio = isRadio;
		this.bus = {};
		this._actual = new Actual();
		this._checkable = checkable;
		this._preFormatFilter = preFormat;
		this._formatFilter = formatFilter;
		this._inputFilter = inputFilter;
		this._outputFilter = outputFilter;
		this._validation = new Validation_Validation(_extends({ formatFilter: formatFilter }, options));
		this._enforceSubmit = enforceSubmit;
		var initialValue = this.getInputValue(pristineValue);
		this._actual.setInitialValue(initialValue);
	}

	PrimitiveStore_createClass(PrimitiveStore, [{
		key: 'getDefaultStoreValue',
		value: function getDefaultStoreValue() {
			return this._options.hasOwnProperty('defaultValue') ? this._options.defaultValue : '';
		}
	}, {
		key: '_try',
		value: function _try(fn) {
			try {
				return Object(external_mobx_["runInAction"])(fn);
			} catch (error) {
				this.errorMessage = error.message || 'Invalid';
			}
		}
	}, {
		key: 'getOutputValue',
		value: function getOutputValue(value) {
			var _this2 = this;

			return this._try(function () {
				var pristineValue = _this2.pristineValue,
				    _outputFilter = _this2._outputFilter,
				    _preFormatFilter = _this2._preFormatFilter,
				    _formatFilter = _this2._formatFilter,
				    _defaultValueFilter = _this2._defaultValueFilter;

				return Object(utils["c" /* filtersFlow */])([_outputFilter, _preFormatFilter, _formatFilter, _defaultValueFilter], value, { pristineValue: pristineValue });
			});
		}
	}, {
		key: 'getInputValue',
		value: function getInputValue(value) {
			var _this3 = this;

			return this._try(function () {
				var _inputFilter = _this3._inputFilter,
				    _defaultValueFilter = _this3._defaultValueFilter;

				return Object(utils["c" /* filtersFlow */])([_inputFilter, _defaultValueFilter], value);
			});
		}
	}, {
		key: 'applyGetValue',
		value: function applyGetValue() {
			var isValueEmpty = this.isValueEmpty,
			    value = this._actual.value;

			return isValueEmpty ? this.getDefaultStoreValue() : value;
		}
	}, {
		key: 'getFormData',
		value: function getFormData() {
			var value = this.getOutputValue(this.value);
			return this.shouldIgnore(value) ? undefined : value;
		}
	}, {
		key: 'touch',
		value: function touch() {
			var isTouched = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

			this.isTouched = isTouched;
		}
	}, {
		key: 'validate',
		value: function validate() {
			var _this4 = this;

			if (!this.errorMessage) {
				this._try(function () {
					_this4._validation.exec(_this4.value);
					_this4.errorMessage = '';
				});
			}
		}
	}, {
		key: 'emitChange',
		value: function emitChange() {
			var _this5 = this;

			this._try(function () {
				_this5._validation.exec(_this5.value);
				_this5.isTouched = true;
				_this5.errorMessage = '';
				_this5.parentStore.change(_this5);
			});
		}
	}, {
		key: 'shouldIgnore',
		value: function shouldIgnore(value) {
			if (this._enforceSubmit || !this.isPristineValueEmpty) return false;
			if (Object(utils["d" /* isArray */])(value)) return !value.length;
			if (Object(utils["j" /* isPlainObject */])(value)) return !Object.keys(value).length;
			return Object(utils["f" /* isEmpty */])(value);
		}
	}, {
		key: 'getValidState',
		value: function getValidState() {
			var isValid = this.isValid,
			    isInvalid = this.isInvalid,
			    isTouched = this.isTouched,
			    errorMessage = this.errorMessage;

			return { isValid: isValid, isInvalid: isInvalid, isTouched: isTouched, errorMessage: errorMessage };
		}
	}]);

	return PrimitiveStore;
}(), (_descriptor6 = _applyDecoratedDescriptor(_class3.prototype, 'isTouched', [external_mobx_["observable"]], {
	enumerable: true,
	initializer: function initializer() {
		return false;
	}
}), _applyDecoratedDescriptor(_class3.prototype, 'pristineValue', [external_mobx_["computed"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'pristineValue'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'sourceValue', [external_mobx_["computed"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'sourceValue'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'value', [external_mobx_["computed"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'value'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'errorMessage', [external_mobx_["computed"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'errorMessage'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isChecked', [external_mobx_["computed"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'isChecked'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isPristineValueEmpty', [external_mobx_["computed"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'isPristineValueEmpty'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isSourceValueEmpty', [external_mobx_["computed"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'isSourceValueEmpty'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isValueEmpty', [external_mobx_["computed"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'isValueEmpty'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isValid', [external_mobx_["computed"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'isValid'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isInvalid', [external_mobx_["computed"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'isInvalid'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'touch', [external_mobx_["action"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'touch'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'emitChange', [external_mobx_["action"]], Object.getOwnPropertyDescriptor(_class3.prototype, 'emitChange'), _class3.prototype)), _class3);


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _implementation = __webpack_require__(16);

var _implementation2 = _interopRequireDefault(_implementation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = _react2.default.createContext || _implementation2.default;
module.exports = exports['default'];

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * @providesModule warning
 */



/**
 * Similar to invariant but only logs a warning if the condition is not met.
 * This can be used to log issues in development environments in critical
 * paths. Removing the logging code for production environments will keep the
 * same logic and follow the same code paths.
 */

var __DEV__ = "production" !== 'production';

var warning = function() {};

if (__DEV__) {
  function printWarning(format, args) {
    var len = arguments.length;
    args = new Array(len > 2 ? len - 2 : 0);
    for (var key = 2; key < len; key++) {
      args[key - 2] = arguments[key];
    }
    var argIndex = 0;
    var message = 'Warning: ' +
      format.replace(/%s/g, function() {
        return args[argIndex++];
      });
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  }

  warning = function(condition, format, args) {
    var len = arguments.length;
    args = new Array(len > 2 ? len - 2 : 0);
    for (var key = 2; key < len; key++) {
      args[key - 2] = arguments[key];
    }
    if (format === undefined) {
      throw new Error(
          '`warning(condition, format, ...args)` requires a warning ' +
          'message argument'
      );
    }
    if (!condition) {
      printWarning.apply(null, [format].concat(args));
    }
  };
}

module.exports = warning;


/***/ }),
/* 10 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: external "React"
var external_React_ = __webpack_require__(2);
var external_React_default = /*#__PURE__*/__webpack_require__.n(external_React_);

// EXTERNAL MODULE: ./node_modules/prop-types/index.js
var prop_types = __webpack_require__(0);
var prop_types_default = /*#__PURE__*/__webpack_require__.n(prop_types);

// EXTERNAL MODULE: external "mobxReact"
var external_mobxReact_ = __webpack_require__(4);

// EXTERNAL MODULE: ./src/utils.js
var utils = __webpack_require__(1);

// EXTERNAL MODULE: ./src/FormatTypes.js
var FormatTypes = __webpack_require__(5);

// EXTERNAL MODULE: ./node_modules/create-react-context/lib/index.js
var lib = __webpack_require__(8);
var lib_default = /*#__PURE__*/__webpack_require__.n(lib);

// CONCATENATED MODULE: ./src/Context.js


/* harmony default export */ var Context = (lib_default()());
// CONCATENATED MODULE: ./node_modules/react-lifecycles-compat/react-lifecycles-compat.es.js
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

function componentWillMount() {
  // Call this.constructor.gDSFP to support sub-classes.
  var state = this.constructor.getDerivedStateFromProps(this.props, this.state);
  if (state !== null && state !== undefined) {
    this.setState(state);
  }
}

function componentWillReceiveProps(nextProps) {
  // Call this.constructor.gDSFP to support sub-classes.
  // Use the setState() updater to ensure state isn't stale in certain edge cases.
  function updater(prevState) {
    var state = this.constructor.getDerivedStateFromProps(nextProps, prevState);
    return state !== null && state !== undefined ? state : null;
  }
  // Binding "this" is important for shallow renderer support.
  this.setState(updater.bind(this));
}

function componentWillUpdate(nextProps, nextState) {
  try {
    var prevProps = this.props;
    var prevState = this.state;
    this.props = nextProps;
    this.state = nextState;
    this.__reactInternalSnapshotFlag = true;
    this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(
      prevProps,
      prevState
    );
  } finally {
    this.props = prevProps;
    this.state = prevState;
  }
}

// React may warn about cWM/cWRP/cWU methods being deprecated.
// Add a flag to suppress these warnings for this special case.
componentWillMount.__suppressDeprecationWarning = true;
componentWillReceiveProps.__suppressDeprecationWarning = true;
componentWillUpdate.__suppressDeprecationWarning = true;

function polyfill(Component) {
  var prototype = Component.prototype;

  if (!prototype || !prototype.isReactComponent) {
    throw new Error('Can only polyfill class components');
  }

  if (
    typeof Component.getDerivedStateFromProps !== 'function' &&
    typeof prototype.getSnapshotBeforeUpdate !== 'function'
  ) {
    return Component;
  }

  // If new component APIs are defined, "unsafe" lifecycles won't be called.
  // Error if any of these lifecycles are present,
  // Because they would work differently between older and newer (16.3+) versions of React.
  var foundWillMountName = null;
  var foundWillReceivePropsName = null;
  var foundWillUpdateName = null;
  if (typeof prototype.componentWillMount === 'function') {
    foundWillMountName = 'componentWillMount';
  } else if (typeof prototype.UNSAFE_componentWillMount === 'function') {
    foundWillMountName = 'UNSAFE_componentWillMount';
  }
  if (typeof prototype.componentWillReceiveProps === 'function') {
    foundWillReceivePropsName = 'componentWillReceiveProps';
  } else if (typeof prototype.UNSAFE_componentWillReceiveProps === 'function') {
    foundWillReceivePropsName = 'UNSAFE_componentWillReceiveProps';
  }
  if (typeof prototype.componentWillUpdate === 'function') {
    foundWillUpdateName = 'componentWillUpdate';
  } else if (typeof prototype.UNSAFE_componentWillUpdate === 'function') {
    foundWillUpdateName = 'UNSAFE_componentWillUpdate';
  }
  if (
    foundWillMountName !== null ||
    foundWillReceivePropsName !== null ||
    foundWillUpdateName !== null
  ) {
    var componentName = Component.displayName || Component.name;
    var newApiName =
      typeof Component.getDerivedStateFromProps === 'function'
        ? 'getDerivedStateFromProps()'
        : 'getSnapshotBeforeUpdate()';

    throw Error(
      'Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n' +
        componentName +
        ' uses ' +
        newApiName +
        ' but also contains the following legacy lifecycles:' +
        (foundWillMountName !== null ? '\n  ' + foundWillMountName : '') +
        (foundWillReceivePropsName !== null
          ? '\n  ' + foundWillReceivePropsName
          : '') +
        (foundWillUpdateName !== null ? '\n  ' + foundWillUpdateName : '') +
        '\n\nThe above lifecycles should be removed. Learn more about this warning here:\n' +
        'https://fb.me/react-async-component-lifecycle-hooks'
    );
  }

  // React <= 16.2 does not support static getDerivedStateFromProps.
  // As a workaround, use cWM and cWRP to invoke the new static lifecycle.
  // Newer versions of React will ignore these lifecycles if gDSFP exists.
  if (typeof Component.getDerivedStateFromProps === 'function') {
    prototype.componentWillMount = componentWillMount;
    prototype.componentWillReceiveProps = componentWillReceiveProps;
  }

  // React <= 16.2 does not support getSnapshotBeforeUpdate.
  // As a workaround, use cWU to invoke the new lifecycle.
  // Newer versions of React will ignore that lifecycle if gSBU exists.
  if (typeof prototype.getSnapshotBeforeUpdate === 'function') {
    if (typeof prototype.componentDidUpdate !== 'function') {
      throw new Error(
        'Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype'
      );
    }

    prototype.componentWillUpdate = componentWillUpdate;

    var componentDidUpdate = prototype.componentDidUpdate;

    prototype.componentDidUpdate = function componentDidUpdatePolyfill(
      prevProps,
      prevState,
      maybeSnapshot
    ) {
      // 16.3+ will not execute our will-update method;
      // It will pass a snapshot value to did-update though.
      // Older versions will require our polyfilled will-update value.
      // We need to handle both cases, but can't just check for the presence of "maybeSnapshot",
      // Because for <= 15.x versions this might be a "prevContext" object.
      // We also can't just check "__reactInternalSnapshot",
      // Because get-snapshot might return a falsy value.
      // So check for the explicit __reactInternalSnapshotFlag flag to determine behavior.
      var snapshot = this.__reactInternalSnapshotFlag
        ? this.__reactInternalSnapshot
        : maybeSnapshot;

      componentDidUpdate.call(this, prevProps, prevState, snapshot);
    };
  }

  return Component;
}



// CONCATENATED MODULE: ./src/withFormStore.js
var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }





function withFormStore() {
	return function createFormStoreComponent(WrappedComponent) {
		var _class, _class2, _temp;

		var displayName = WrappedComponent.displayName,
		    name = WrappedComponent.name;

		var WithFormStore = polyfill(_class = (_temp = _class2 = function (_Component) {
			_inherits(WithFormStore, _Component);

			function WithFormStore() {
				_classCallCheck(this, WithFormStore);

				return _possibleConstructorReturn(this, (WithFormStore.__proto__ || Object.getPrototypeOf(WithFormStore)).apply(this, arguments));
			}

			_createClass(WithFormStore, [{
				key: 'getValue',
				value: function getValue() {
					return this.wrapped.inputStore.value;
				}
			}, {
				key: 'setValue',
				value: function setValue(value) {
					this.wrapped.inputStore.value = value;
				}
			}, {
				key: 'getPristineValue',
				value: function getPristineValue() {
					return this.wrapped.inputStore.pristineValue;
				}
			}, {
				key: 'setPristineValue',
				value: function setPristineValue(value) {
					this.wrapped.inputStore.pristineValue = value;
				}
			}, {
				key: 'getValidState',
				value: function getValidState() {
					return this.wrapped.inputStore.getValidState();
				}
			}, {
				key: 'submit',
				value: function submit() {
					return this.wrapped.inputStore.submit();
				}
			}, {
				key: 'clear',
				value: function clear() {
					return this.wrapped.inputStore.clear();
				}
			}, {
				key: 'reset',
				value: function reset() {
					return this.wrapped.inputStore.reset();
				}
			}, {
				key: 'render',
				value: function render() {
					var _this2 = this;

					return external_React_default.a.createElement(
						Context.Consumer,
						null,
						function (formStore) {
							return external_React_default.a.createElement(WrappedComponent, _extends({}, _this2.props, {
								formStore: formStore,
								ref: function ref(wrapped) {
									return _this2.wrapped = wrapped;
								}
							}));
						}
					);
				}
			}]);

			return WithFormStore;
		}(external_React_["Component"]), _class2.displayName = 'WithFormStore(' + (displayName || name) + ')', _temp)) || _class;

		return WithFormStore;
	};
}
// CONCATENATED MODULE: ./src/Demon.js
var Demon_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var Demon_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, Demon_class, Demon_class2, Demon_temp, Demon_initialiseProps;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function Demon_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function Demon_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function Demon_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }









var Demon_Demon = (_dec = withFormStore(), _dec(Demon_class = Object(external_mobxReact_["observer"])(Demon_class = (Demon_temp = Demon_class2 = function (_Component) {
	Demon_inherits(Demon, _Component);

	function Demon(props) {
		Demon_classCallCheck(this, Demon);

		var _this = Demon_possibleConstructorReturn(this, (Demon.__proto__ || Object.getPrototypeOf(Demon)).call(this, props));

		Demon_initialiseProps.call(_this);

		var forwardedProps = props.forwardedProps,
		    formStore = props.formStore,
		    isObject = props.isObject,
		    isArray = props.isArray,
		    checkable = props.checkable,
		    isRadio = props.isRadio,
		    propOnChange = props.propOnChange;

		var name = forwardedProps.name,
		    otherForwardedProps = _objectWithoutProperties(forwardedProps, ['name']);

		var options = Demon_extends({
			isObject: isObject,
			isArray: isArray,
			checkable: checkable,
			isRadio: isRadio
		}, otherForwardedProps);

		if (checkable && Object(utils["f" /* isEmpty */])(forwardedProps.value)) {
			options.value = true;
			if (!forwardedProps.format) options.format = 'boolean';
		}

		if (isObject) {
			options.onChange = otherForwardedProps[propOnChange];
		}

		_this.inputStore = formStore.attach(name, options);
		_this.inputStore.validate();
		return _this;
	}

	Demon_createClass(Demon, [{
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.props.formStore.detach(this.inputStore.key);
		}
	}, {
		key: 'renderChildren',
		value: function renderChildren() {
			var _extends2;

			var inputStore = this.inputStore,
			    _inputStore = this.inputStore,
			    value = _inputStore.value,
			    isChecked = _inputStore.isChecked,
			    _props = this.props,
			    _props$forwardedProps = _props.forwardedProps,
			    defaultValue = _props$forwardedProps.defaultValue,
			    defaultChecked = _props$forwardedProps.defaultChecked,
			    name = _props$forwardedProps.name,
			    preValidate = _props$forwardedProps.preValidate,
			    validation = _props$forwardedProps.validation,
			    inputFilter = _props$forwardedProps.inputFilter,
			    outputFilter = _props$forwardedProps.outputFilter,
			    preFormat = _props$forwardedProps.preFormat,
			    format = _props$forwardedProps.format,
			    formatFunc = _props$forwardedProps.formatFunc,
			    enforceSubmit = _props$forwardedProps.enforceSubmit,
			    enumeration = _props$forwardedProps.enum,
			    pattern = _props$forwardedProps.pattern,
			    maxLength = _props$forwardedProps.maxLength,
			    minLength = _props$forwardedProps.minLength,
			    maximum = _props$forwardedProps.maximum,
			    exclusiveMaximum = _props$forwardedProps.exclusiveMaximum,
			    minimum = _props$forwardedProps.minimum,
			    exclusiveMinimum = _props$forwardedProps.exclusiveMinimum,
			    forwardedProps = _objectWithoutProperties(_props$forwardedProps, ['defaultValue', 'defaultChecked', 'name', 'preValidate', 'validation', 'inputFilter', 'outputFilter', 'preFormat', 'format', 'formatFunc', 'enforceSubmit', 'enum', 'pattern', 'maxLength', 'minLength', 'maximum', 'exclusiveMaximum', 'minimum', 'exclusiveMinimum']),
			    propOnChange = _props.propOnChange,
			    propOnKeyPress = _props.propOnKeyPress,
			    propOnBlur = _props.propOnBlur,
			    checkable = _props.checkable,
			    children = _props.children;

			var props = Demon_extends({
				value: value
			}, forwardedProps, (_extends2 = {}, _defineProperty(_extends2, propOnChange, this.handleChange), _defineProperty(_extends2, propOnKeyPress, this.handleKeyPress), _defineProperty(_extends2, propOnBlur, this.handleBlur), _extends2));
			var validState = inputStore.getValidState();
			if (checkable && !props.hasOwnProperty('checked')) {
				props.checked = isChecked;
			}
			return external_React_["Children"].only(children(props, validState));
		}
	}, {
		key: 'render',
		value: function render() {
			var inputStore = this.inputStore,
			    _props2 = this.props,
			    children = _props2.children,
			    isObject = _props2.isObject;

			return isObject ? external_React_default.a.createElement(
				Context.Provider,
				{ value: inputStore },
				children()
			) : this.renderChildren();
		}
	}]);

	return Demon;
}(external_React_["Component"]), Demon_class2.propTypes = {
	children: prop_types_default.a.func.isRequired,
	formStore: prop_types_default.a.object.isRequired,
	forwardedProps: prop_types_default.a.shape({
		name: prop_types_default.a.string.isRequired,
		value: prop_types_default.a.any,
		defaultValue: prop_types_default.a.any,
		preValidate: prop_types_default.a.func,
		validation: prop_types_default.a.oneOfType([prop_types_default.a.arrayOf(prop_types_default.a.func), prop_types_default.a.func]),
		required: prop_types_default.a.bool,
		inputFilter: prop_types_default.a.func,
		outputFilter: prop_types_default.a.func,
		preFormat: prop_types_default.a.func,
		format: prop_types_default.a.oneOf(FormatTypes["a" /* FormatTypesKeys */]),
		formatFunc: prop_types_default.a.func,
		enforceSubmit: prop_types_default.a.bool,

		enum: prop_types_default.a.array,
		pattern: prop_types_default.a.instanceOf(RegExp),
		maxLength: prop_types_default.a.number,
		minLength: prop_types_default.a.number,
		maximum: prop_types_default.a.number,
		exclusiveMaximum: prop_types_default.a.number,
		minimum: prop_types_default.a.number,
		exclusiveMinimum: prop_types_default.a.number
	}).isRequired,

	checkable: prop_types_default.a.bool,
	isRadio: prop_types_default.a.bool,

	getValueFromChangeEvent: prop_types_default.a.func,
	getCheckedFromChangeEvent: prop_types_default.a.func,
	getKeyFromKeyPressEvent: prop_types_default.a.func,
	propOnChange: prop_types_default.a.string,
	propOnKeyPress: prop_types_default.a.string,
	propOnBlur: prop_types_default.a.string,

	isObject: prop_types_default.a.bool,
	isArray: prop_types_default.a.bool
}, Demon_class2.defaultProps = {
	forwardedProps: {},
	checkable: false,
	isRadio: false,
	getValueFromChangeEvent: function getValueFromChangeEvent(ev) {
		return ev.currentTarget.value;
	},
	getCheckedFromChangeEvent: function getCheckedFromChangeEvent(ev) {
		return ev.currentTarget.checked;
	},
	getKeyFromKeyPressEvent: function getKeyFromKeyPressEvent(ev) {
		return ev.key;
	},
	propOnChange: 'onChange',
	propOnKeyPress: 'onKeyPress',
	propOnBlur: 'onBlur',
	isObject: false,
	isArray: false
}, Demon_initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.handleChange = function () {
		var _props3 = _this2.props,
		    forwardedProps = _props3.forwardedProps,
		    checkable = _props3.checkable,
		    getValueFromChangeEvent = _props3.getValueFromChangeEvent,
		    getCheckedFromChangeEvent = _props3.getCheckedFromChangeEvent,
		    propOnChange = _props3.propOnChange;

		var onChange = forwardedProps[propOnChange];
		if (Object(utils["g" /* isFunction */])(onChange)) onChange.apply(undefined, arguments);

		if (checkable) {
			try {
				var checked = getCheckedFromChangeEvent.apply(undefined, arguments);
				_this2.inputStore.isChecked = checked;
			} catch (err) {
				Object(utils["o" /* warn */])('Failed to get checked from "' + propOnChange + '",', 'changing "props.getCheckedFromChangeEvent" may resolve this problem.');
				console.error(err);
			}
		} else {
			try {
				var value = getValueFromChangeEvent.apply(undefined, arguments);
				_this2.inputStore.value = value;
			} catch (err) {
				Object(utils["o" /* warn */])('Failed to get value from "' + propOnChange + '",', 'changing "props.getValueFromChangeEvent" may resolve this problem.');
				console.error(err);
			}
		}

		_this2.inputStore.emitChange();
	};

	this.handleKeyPress = function () {
		var _props4 = _this2.props,
		    forwardedProps = _props4.forwardedProps,
		    formStore = _props4.formStore,
		    propOnKeyPress = _props4.propOnKeyPress,
		    getKeyFromKeyPressEvent = _props4.getKeyFromKeyPressEvent;

		var onKeyPress = forwardedProps[propOnKeyPress];
		if (Object(utils["g" /* isFunction */])(onKeyPress)) onKeyPress.apply(undefined, arguments);
		var key = void 0;
		try {
			key = getKeyFromKeyPressEvent.apply(undefined, arguments);
		} catch (err) {
			Object(utils["o" /* warn */])('Failed to get key from "' + propOnKeyPress + '",', 'changing "props.getKeyFromKeyPressEvent" may resolve this problem.');
			console.error(err);
		}
		if (key === 'Enter') formStore.submit();
	};

	this.handleBlur = function () {
		var _props5 = _this2.props,
		    forwardedProps = _props5.forwardedProps,
		    propOnBlur = _props5.propOnBlur;

		var onBlur = forwardedProps[propOnBlur];
		if (Object(utils["g" /* isFunction */])(onBlur)) onBlur.apply(undefined, arguments);
		_this2.inputStore.touch();
	};
}, Demon_temp)) || Demon_class) || Demon_class);

// CONCATENATED MODULE: ./src/DemonButton.js
var DemonButton_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var DemonButton_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var DemonButton_dec, DemonButton_class, DemonButton_class2, _temp2, DemonButton_initialiseProps;

function DemonButton_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function DemonButton_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function DemonButton_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function DemonButton_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }






var DemonButton_DemonButton = (DemonButton_dec = withFormStore(), DemonButton_dec(DemonButton_class = (_temp2 = DemonButton_class2 = function (_Component) {
	DemonButton_inherits(DemonButton, _Component);

	function DemonButton() {
		var _ref;

		var _temp, _this, _ret;

		DemonButton_classCallCheck(this, DemonButton);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = DemonButton_possibleConstructorReturn(this, (_ref = DemonButton.__proto__ || Object.getPrototypeOf(DemonButton)).call.apply(_ref, [this].concat(args))), _this), DemonButton_initialiseProps.call(_this), _temp), DemonButton_possibleConstructorReturn(_this, _ret);
	}

	DemonButton_createClass(DemonButton, [{
		key: 'emit',
		value: function emit() {
			var _props = this.props,
			    formStore = _props.formStore,
			    type = _props.type;

			formStore[type]();
		}
	}, {
		key: 'render',
		value: function render() {
			var _extends2;

			var _props2 = this.props,
			    forwardedProps = _props2.forwardedProps,
			    propOnClick = _props2.propOnClick,
			    propOnKeyPress = _props2.propOnKeyPress,
			    children = _props2.children;

			var props = DemonButton_extends({}, forwardedProps, (_extends2 = {}, DemonButton_defineProperty(_extends2, propOnClick, this.handleClick), DemonButton_defineProperty(_extends2, propOnKeyPress, this.handleKeyPress), _extends2));
			return external_React_["Children"].only(children(props));
		}
	}]);

	return DemonButton;
}(external_React_["Component"]), DemonButton_class2.propTypes = {
	children: prop_types_default.a.func.isRequired,
	type: prop_types_default.a.oneOf(['submit', 'reset', 'clear']),
	formStore: prop_types_default.a.shape({
		disabled: prop_types_default.a.bool
	}).isRequired,
	forwardedProps: prop_types_default.a.object,
	getKeyFromKeyPressEvent: prop_types_default.a.func,
	propOnClick: prop_types_default.a.string,
	propOnKeyPress: prop_types_default.a.string
}, DemonButton_class2.defaultProps = {
	forwardedProps: {},
	type: 'submit',
	getKeyFromKeyPressEvent: function getKeyFromKeyPressEvent(ev) {
		return ev.key;
	},
	propOnClick: 'onClick',
	propOnKeyPress: 'onKeyPress'
}, DemonButton_initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.handleClick = function () {
		var _props3 = _this2.props,
		    forwardedProps = _props3.forwardedProps,
		    propOnClick = _props3.propOnClick;

		var onClick = forwardedProps[propOnClick];
		if (Object(utils["g" /* isFunction */])(onClick)) onClick.apply(undefined, arguments);
		_this2.emit();
	};

	this.handleKeyPress = function () {
		var _props4 = _this2.props,
		    forwardedProps = _props4.forwardedProps,
		    propOnKeyPress = _props4.propOnKeyPress,
		    getKeyFromKeyPressEvent = _props4.getKeyFromKeyPressEvent;

		var onKeyPress = forwardedProps[propOnKeyPress];
		if (Object(utils["g" /* isFunction */])(onKeyPress)) onKeyPress.apply(undefined, arguments);
		try {
			var key = getKeyFromKeyPressEvent.apply(undefined, arguments);

			/* istanbul ignore else */
			if (key === 'Enter') _this2.emit();
		} catch (err) /* istanbul ignore next */{
			Object(utils["o" /* warn */])('Failed to get value from "' + propOnKeyPress + '",', 'changing "props.getKeyFromKeyPressEvent" may resolve this problem.');
			console.error(err);
		}
	};
}, _temp2)) || DemonButton_class);

// EXTERNAL MODULE: external "mobx"
var external_mobx_ = __webpack_require__(3);

// EXTERNAL MODULE: ./src/FormStore/PrimitiveStore.js + 1 modules
var PrimitiveStore = __webpack_require__(7);

// EXTERNAL MODULE: ./src/FormStore/ObjectStore.js
var ObjectStore = __webpack_require__(6);

// CONCATENATED MODULE: ./src/FormStore/ArrayStore.js
var ArrayStore_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, ArrayStore_class, _descriptor, _descriptor2, _descriptor3;

function _initDefineProp(target, property, descriptor, context) {
	if (!descriptor) return;
	Object.defineProperty(target, property, {
		enumerable: descriptor.enumerable,
		configurable: descriptor.configurable,
		writable: descriptor.writable,
		value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
	});
}

function ArrayStore_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function ArrayStore_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function ArrayStore_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}

function _initializerWarningHelper(descriptor, context) {
	throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}





var ArrayStore_ArrayStore = (ArrayStore_class = function (_ObjectStore) {
	ArrayStore_inherits(ArrayStore, _ObjectStore);

	function ArrayStore(pristineValue, options) {
		ArrayStore_classCallCheck(this, ArrayStore);

		var _this = ArrayStore_possibleConstructorReturn(this, (ArrayStore.__proto__ || Object.getPrototypeOf(ArrayStore)).call(this, pristineValue, options));

		_initDefineProp(_this, 'ids', _descriptor, _this);

		_this._index = 0;

		_initDefineProp(_this, 'push', _descriptor2, _this);

		_initDefineProp(_this, 'remove', _descriptor3, _this);

		_this._isRadioGroup = options.isRadioGroup;
		_this.children = Object(external_mobx_["observable"])([]);
		return _this;
	}

	ArrayStore_createClass(ArrayStore, [{
		key: 'getDefaultStoreValue',
		value: function getDefaultStoreValue() {
			return [];
		}
	}, {
		key: 'applySetValue',
		value: function applySetValue(value) {
			this.eachChildren(function (child, index) {
				child.value = value[index];
			});
		}
	}, {
		key: 'applySetPristineValue',
		value: function applySetPristineValue() {
			var _this2 = this;

			this.isChecked = false;
			var keysToBeDeleted = [];
			var keysToBeAdded = this.sourceValue.slice(this.children.length);
			this.eachChildren(function (child, key) {
				if (key < _this2.sourceValue.length) {
					var val = _this2.sourceValue[key];
					child.pristineValue = val;
				} else {
					keysToBeDeleted.push(child.key);
				}
			});
			keysToBeDeleted.forEach(function (key) {
				_this2.detach(key);
				_this2.remove(key);
			});
			keysToBeAdded.forEach(function () {
				_this2.push(Object(utils["b" /* createId */])(_this2.key));
			});
		}
	}, {
		key: 'getFormData',
		value: function getFormData() {
			var _this3 = this;

			var res = this.getDefaultStoreValue();
			this.eachChildren(function (child) {
				var val = child.getFormData();

				/* istanbul ignore else */
				if (!_this3.shouldIgnore(val)) res.push(val);
			});
			var value = this.getOutputValue(res);
			return this.shouldIgnore(value) ? undefined : value;
		}
	}, {
		key: '_findIndexByKey',
		value: function _findIndexByKey(key) {
			return this.children.findIndex(function (item) {
				return item.key === key;
			});
		}
	}, {
		key: 'eachChildren',
		value: function eachChildren(iterator) {
			var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
			var _options$checked = options.checked,
			    checked = _options$checked === undefined ? true : _options$checked;

			var filter = function filter(item) {
				return item.isChecked;
			};
			var index = 0;
			this.children.forEach(function (item, _) {
				for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
					args[_key - 2] = arguments[_key];
				}

				if (!checked || filter(item)) iterator.apply(undefined, [item, index++].concat(args));
			});
		}
	}, {
		key: 'getChildren',
		value: function getChildren(key) {
			var index = this._findIndexByKey(key);
			if (~index) return this.children[index];
		}
	}, {
		key: 'setChildren',
		value: function setChildren(key, store) {
			var index = this._findIndexByKey(key);

			/* istanbul ignore else */
			if (index < 0) index = this.children.length;

			this.children[index] = store;
			return true;
		}
	}, {
		key: 'shouldCheck',
		value: function shouldCheck(key, value) {
			var sourceValue = this.sourceValue;

			var checked = !!~sourceValue.indexOf(value);
			if (checked) return checked;
			if (value === true) return !!~sourceValue.indexOf('true');
			return false;
		}
	}, {
		key: 'hasKey',
		value: function hasKey(key) {
			if (this._isRadioGroup) return this.parentStore.hasKey(this.key);

			var matched = false;
			this.eachChildren(function (child) {
				if (!matched) matched = key === child.key;
			}, { checked: false });
			return matched;
		}
	}, {
		key: 'attach',
		value: function attach(key, options) {
			var sourceValue = this.sourceValue,
			    form = this.form;
			var isRadioGroup = options.isRadioGroup;

			var index = isRadioGroup ? --this._index : this._index++;
			var value = index >= sourceValue.length ? '' : sourceValue[index];
			return form.createChildren(this, key, value, options);
		}
	}, {
		key: 'detach',
		value: function detach(key) {
			var index = this._findIndexByKey(key);
			if (index < 0) return;
			this.sourceValue.splice(index, 1);
			this.children.splice(index, 1);
		}
	}, {
		key: 'checkKey',
		value: function checkKey(key) {
			this.eachChildren(function (child) {
				if (child.isChecked && child.key !== key) {
					child.isChecked = false;
				}
			}, { checked: false });
		}
	}]);

	return ArrayStore;
}(ObjectStore["a" /* default */]), (_descriptor = _applyDecoratedDescriptor(ArrayStore_class.prototype, 'ids', [external_mobx_["observable"]], {
	enumerable: true,
	initializer: function initializer() {
		return [];
	}
}), _applyDecoratedDescriptor(ArrayStore_class.prototype, 'applySetValue', [external_mobx_["action"]], Object.getOwnPropertyDescriptor(ArrayStore_class.prototype, 'applySetValue'), ArrayStore_class.prototype), _applyDecoratedDescriptor(ArrayStore_class.prototype, 'applySetPristineValue', [external_mobx_["action"]], Object.getOwnPropertyDescriptor(ArrayStore_class.prototype, 'applySetPristineValue'), ArrayStore_class.prototype), _applyDecoratedDescriptor(ArrayStore_class.prototype, 'setChildren', [external_mobx_["action"]], Object.getOwnPropertyDescriptor(ArrayStore_class.prototype, 'setChildren'), ArrayStore_class.prototype), _applyDecoratedDescriptor(ArrayStore_class.prototype, 'attach', [external_mobx_["action"]], Object.getOwnPropertyDescriptor(ArrayStore_class.prototype, 'attach'), ArrayStore_class.prototype), _applyDecoratedDescriptor(ArrayStore_class.prototype, 'detach', [external_mobx_["action"]], Object.getOwnPropertyDescriptor(ArrayStore_class.prototype, 'detach'), ArrayStore_class.prototype), _descriptor2 = _applyDecoratedDescriptor(ArrayStore_class.prototype, 'push', [external_mobx_["action"]], {
	enumerable: true,
	initializer: function initializer() {
		var _this4 = this;

		return function (id) {
			return _this4.ids.push(id);
		};
	}
}), _descriptor3 = _applyDecoratedDescriptor(ArrayStore_class.prototype, 'remove', [external_mobx_["action"]], {
	enumerable: true,
	initializer: function initializer() {
		var _this5 = this;

		return function (id) {
			var removed = _this5.ids.remove(id);

			/* istanbul ignore else */
			if (removed) _this5._index--;

			return removed;
		};
	}
}), _applyDecoratedDescriptor(ArrayStore_class.prototype, 'checkKey', [external_mobx_["action"]], Object.getOwnPropertyDescriptor(ArrayStore_class.prototype, 'checkKey'), ArrayStore_class.prototype)), ArrayStore_class);

// CONCATENATED MODULE: ./src/FormStore/FormStore.js
var FormStore_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var FormStore_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var FormStore_desc, FormStore_value, FormStore_class, FormStore_descriptor, FormStore_descriptor2, FormStore_descriptor3;

function FormStore_initDefineProp(target, property, descriptor, context) {
	if (!descriptor) return;
	Object.defineProperty(target, property, {
		enumerable: descriptor.enumerable,
		configurable: descriptor.configurable,
		writable: descriptor.writable,
		value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
	});
}

function FormStore_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function FormStore_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function FormStore_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function FormStore_initializerWarningHelper(descriptor, context) {
	throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

function FormStore_applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}







var FormStore_FormStore = (FormStore_class = function (_ObjectStore) {
	FormStore_inherits(FormStore, _ObjectStore);

	function FormStore(pristineValue, options) {
		FormStore_classCallCheck(this, FormStore);

		var _this = FormStore_possibleConstructorReturn(this, (FormStore.__proto__ || Object.getPrototypeOf(FormStore)).call(this, pristineValue, FormStore_extends({}, options, {
			key: '<FORM>'
		})));

		FormStore_initDefineProp(_this, 'submit', FormStore_descriptor, _this);

		FormStore_initDefineProp(_this, 'reset', FormStore_descriptor2, _this);

		FormStore_initDefineProp(_this, 'clear', FormStore_descriptor3, _this);

		var submit = options.submit,
		    clear = options.clear,
		    reset = options.reset,
		    change = options.change;

		_this.bus = FormStore_extends({}, _this.bus, {
			submit: submit,
			change: change,
			clear: clear,
			reset: reset
		});
		return _this;
	}

	FormStore_createClass(FormStore, [{
		key: 'createChildren',
		value: function createChildren(parentStore, key, value, options) {
			var isArray = options.isArray,
			    isObject = options.isObject,
			    isRadio = options.isRadio;


			if (isRadio) {
				var _store = parentStore.getChildren(key);
				if (!_store) {
					_store = parentStore.attach(key, {
						isArray: true,
						isObject: true,
						isRadioGroup: true,
						parentStore: parentStore,
						inputFilter: function inputFilter(val) {
							return [val];
						},
						outputFilter: function outputFilter(val) {
							return val[0];
						},
						onChange: function onChange(_ref) {
							var key = _ref.key;
							return _store.checkKey(key);
						}
					});
				}

				return _store.attach(Object(utils["b" /* createId */])(key), FormStore_extends({}, options, {
					isRadio: false
				}));
			}

			var Store = function () {
				if (isArray) return ArrayStore_ArrayStore;
				if (isObject) return ObjectStore["a" /* default */];
				return PrimitiveStore["a" /* default */];
			}();

			var checkable = options.checkable,
			    propValue = options.value;

			var finalPristineValue = checkable ? propValue : value;
			var store = new Store(finalPristineValue, FormStore_extends({}, options, {
				key: key,
				form: this,
				parentStore: parentStore
			}));
			parentStore.setChildren(key, store);
			return store;
		}
	}]);

	return FormStore;
}(ObjectStore["a" /* default */]), (FormStore_applyDecoratedDescriptor(FormStore_class.prototype, 'createChildren', [external_mobx_["action"]], Object.getOwnPropertyDescriptor(FormStore_class.prototype, 'createChildren'), FormStore_class.prototype), FormStore_descriptor = FormStore_applyDecoratedDescriptor(FormStore_class.prototype, 'submit', [external_mobx_["action"]], {
	enumerable: true,
	initializer: function initializer() {
		var _this2 = this;

		return function () {
			var isValid = _this2.isValid;
			var submit = _this2.bus.submit;

			_this2.touch();

			/* istanbul ignore else */
			if (Object(utils["g" /* isFunction */])(submit)) {
				var value = _this2.getFormData();
				submit(value, { isValid: isValid });
				return isValid ? value : null;
			}
		};
	}
}), FormStore_descriptor2 = FormStore_applyDecoratedDescriptor(FormStore_class.prototype, 'reset', [external_mobx_["action"]], {
	enumerable: true,
	initializer: function initializer() {
		var _this3 = this;

		return function () {
			var pristineValue = _this3.pristineValue;

			_this3.pristineValue = pristineValue;
			return pristineValue;
		};
	}
}), FormStore_descriptor3 = FormStore_applyDecoratedDescriptor(FormStore_class.prototype, 'clear', [external_mobx_["action"]], {
	enumerable: true,
	initializer: function initializer() {
		var _this4 = this;

		return function () {
			return _this4.pristineValue = {};
		};
	}
})), FormStore_class);

// CONCATENATED MODULE: ./src/FormStore/index.js


// CONCATENATED MODULE: ./src/Form.js
var Form_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var Form_class, Form_class2, Form_temp;

function Form_objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function Form_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function Form_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function Form_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }









var Form_Form = Object(external_mobxReact_["observer"])(Form_class = (Form_temp = Form_class2 = function (_Component) {
	Form_inherits(Form, _Component);

	function Form(props) {
		Form_classCallCheck(this, Form);

		var _this = Form_possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this, props));

		var onSubmit = props.onSubmit,
		    onValidChange = props.onValidChange,
		    onValid = props.onValid,
		    onInvalid = props.onInvalid,
		    onChange = props.onChange,
		    value = props.value,
		    inputFilter = props.inputFilter,
		    outputFilter = props.outputFilter;

		var formStore = new FormStore_FormStore(value, {
			submit: onSubmit,
			change: onChange,
			isObject: true,
			inputFilter: inputFilter,
			outputFilter: outputFilter
		});
		_this.formStore = formStore;

		_this.removeValidListener = Object(external_mobx_["observe"])(formStore, 'isValid', function (_ref) {
			var type = _ref.type,
			    newValue = _ref.newValue;

			/* istanbul ignore else */
			if (type === 'update') {
				onValidChange(newValue);
				newValue ? onValid() : onInvalid();
			}
		});
		return _this;
	}

	Form_createClass(Form, [{
		key: 'componentDidUpdate',
		value: function componentDidUpdate(prevProps) {
			var value = this.props.value;

			/* istanbul ignore else */

			if (prevProps.value !== value) {
				this.formStore.pristineValue = value;
				this.formStore.touch(false);
			}
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.removeValidListener();
		}
	}, {
		key: 'submit',
		value: function submit() {
			return this.formStore.submit();
		}
	}, {
		key: 'reset',
		value: function reset() {
			return this.formStore.reset();
		}
	}, {
		key: 'clear',
		value: function clear() {
			return this.formStore.clear();
		}
	}, {
		key: 'getValue',
		value: function getValue() {
			return this.formStore.value;
		}
	}, {
		key: 'setValue',
		value: function setValue(value) {
			this.formStore.value = value;
		}
	}, {
		key: 'getPristineValue',
		value: function getPristineValue() {
			return this.formStore.pristineValue;
		}
	}, {
		key: 'setPristineValue',
		value: function setPristineValue(value) {
			this.formStore.pristineValue = value;
		}
	}, {
		key: 'getValidState',
		value: function getValidState() {
			return this.formStore.getValidState();
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    Comp = _props.component,
			    value = _props.value,
			    onValidChange = _props.onValidChange,
			    onValid = _props.onValid,
			    onInvalid = _props.onInvalid,
			    onChange = _props.onChange,
			    inputFilter = _props.inputFilter,
			    outputFilter = _props.outputFilter,
			    other = Form_objectWithoutProperties(_props, ['component', 'value', 'onValidChange', 'onValid', 'onInvalid', 'onChange', 'inputFilter', 'outputFilter']);

			return external_React_default.a.createElement(
				Context.Provider,
				{ value: this.formStore },
				external_React_default.a.createElement(Comp, other)
			);
		}
	}]);

	return Form;
}(external_React_["Component"]), Form_class2.propTypes = {
	value: prop_types["object"],
	onSubmit: prop_types["func"],
	onValidChange: prop_types["func"],
	onValid: prop_types["func"],
	onInvalid: prop_types["func"],
	onChange: prop_types["func"],
	inputFilter: prop_types["func"],
	outputFilter: prop_types["func"],
	component: Object(prop_types["oneOfType"])([prop_types["func"], prop_types["string"], prop_types["object"]])
}, Form_class2.defaultProps = {
	value: {},
	onSubmit: utils["l" /* noop */],
	onValidChange: utils["l" /* noop */],
	onValid: utils["l" /* noop */],
	onInvalid: utils["l" /* noop */],
	component: 'div'
}, Form_temp)) || Form_class;


// CONCATENATED MODULE: ./src/Submit.js
var Submit_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var Submit_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function Submit_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function Submit_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function Submit_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }




var Submit_Submit = function (_Component) {
	Submit_inherits(Submit, _Component);

	function Submit() {
		Submit_classCallCheck(this, Submit);

		return Submit_possibleConstructorReturn(this, (Submit.__proto__ || Object.getPrototypeOf(Submit)).apply(this, arguments));
	}

	Submit_createClass(Submit, [{
		key: 'render',
		value: function render() {
			return external_React_default.a.createElement(
				DemonButton_DemonButton,
				{ forwardedProps: this.props },
				function (forwardedProps) {
					return external_React_default.a.createElement('button', Submit_extends({}, forwardedProps, { type: 'button' }));
				}
			);
		}
	}]);

	return Submit;
}(external_React_["Component"]);


// CONCATENATED MODULE: ./src/Reset.js
var Reset_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var Reset_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function Reset_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function Reset_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function Reset_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }




var Reset_Reset = function (_Component) {
	Reset_inherits(Reset, _Component);

	function Reset() {
		Reset_classCallCheck(this, Reset);

		return Reset_possibleConstructorReturn(this, (Reset.__proto__ || Object.getPrototypeOf(Reset)).apply(this, arguments));
	}

	Reset_createClass(Reset, [{
		key: 'render',
		value: function render() {
			return external_React_default.a.createElement(
				DemonButton_DemonButton,
				{ forwardedProps: this.props, type: 'reset' },
				function (forwardedProps) {
					return external_React_default.a.createElement('button', Reset_extends({}, forwardedProps, { type: 'button' }));
				}
			);
		}
	}]);

	return Reset;
}(external_React_["Component"]);


// CONCATENATED MODULE: ./src/Clear.js
var Clear_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var Clear_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function Clear_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function Clear_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function Clear_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }




var Clear_Clear = function (_Component) {
	Clear_inherits(Clear, _Component);

	function Clear() {
		Clear_classCallCheck(this, Clear);

		return Clear_possibleConstructorReturn(this, (Clear.__proto__ || Object.getPrototypeOf(Clear)).apply(this, arguments));
	}

	Clear_createClass(Clear, [{
		key: 'render',
		value: function render() {
			return external_React_default.a.createElement(
				DemonButton_DemonButton,
				{ forwardedProps: this.props, type: 'clear' },
				function (forwardedProps) {
					return external_React_default.a.createElement('button', Clear_extends({}, forwardedProps, { type: 'button' }));
				}
			);
		}
	}]);

	return Clear;
}(external_React_["Component"]);


// CONCATENATED MODULE: ./src/ObjectOf.js
var ObjectOf_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var ObjectOf_class, ObjectOf_temp;

function ObjectOf_objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function ObjectOf_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function ObjectOf_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function ObjectOf_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }





var ObjectOf_ObjectOf = (ObjectOf_temp = ObjectOf_class = function (_Component) {
	ObjectOf_inherits(ObjectOf, _Component);

	function ObjectOf(props) {
		ObjectOf_classCallCheck(this, ObjectOf);

		var _this = ObjectOf_possibleConstructorReturn(this, (ObjectOf.__proto__ || Object.getPrototypeOf(ObjectOf)).call(this, props));

		var children = props.children,
		    forwardedProps = ObjectOf_objectWithoutProperties(props, ['children']);

		_this.forwardedProps = forwardedProps;
		return _this;
	}

	ObjectOf_createClass(ObjectOf, [{
		key: 'getValue',
		value: function getValue() {
			return this.demon.getValue();
		}
	}, {
		key: 'setValue',
		value: function setValue(value) {
			this.demon.setValue(value);
		}
	}, {
		key: 'getPristineValue',
		value: function getPristineValue() {
			return this.demon.getPristineValue();
		}
	}, {
		key: 'setPristineValue',
		value: function setPristineValue(value) {
			this.demon.setPristineValue(value);
		}
	}, {
		key: 'getValidState',
		value: function getValidState() {
			return this.demon.getValidState();
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var children = this.props.children;

			return external_React_default.a.createElement(
				Demon_Demon,
				{
					forwardedProps: this.forwardedProps,
					isObject: true,
					ref: function ref(demon) {
						return _this2.demon = demon;
					}
				},
				function () {
					return children;
				}
			);
		}
	}]);

	return ObjectOf;
}(external_React_["Component"]), ObjectOf_class.propTypes = {
	children: prop_types_default.a.node,
	name: prop_types_default.a.string.isRequired
}, ObjectOf_temp);

// CONCATENATED MODULE: ./src/ArrayOf.js
var ArrayOf_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var ArrayOf_dec, ArrayOf_class, ArrayOf_class2, ArrayOf_temp, _class3, _class4, ArrayOf_temp2;

function ArrayOf_objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function ArrayOf_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function ArrayOf_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function ArrayOf_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }








var childrenType = prop_types_default.a.oneOfType([prop_types_default.a.func, prop_types_default.a.node]).isRequired;

var ArrayOf_ItemGroup = (ArrayOf_dec = withFormStore(), ArrayOf_dec(ArrayOf_class = Object(external_mobxReact_["observer"])(ArrayOf_class = (ArrayOf_temp = ArrayOf_class2 = function (_Component) {
	ArrayOf_inherits(ItemGroup, _Component);

	function ItemGroup(props) {
		ArrayOf_classCallCheck(this, ItemGroup);

		var _this = ArrayOf_possibleConstructorReturn(this, (ItemGroup.__proto__ || Object.getPrototypeOf(ItemGroup)).call(this, props));

		var formStore = props.formStore,
		    name = props.name,
		    children = props.children;

		var createId = function createId() {
			return Object(utils["b" /* createId */])(name);
		};
		var length = Object(utils["g" /* isFunction */])(children) ? formStore.sourceValue.length : external_React_["Children"].count(children);

		_this.helper = {
			createId: createId,
			push: function push() {
				return formStore.push(createId());
			},
			remove: formStore.remove,
			removeBy: function removeBy(id) {
				return function () {
					return formStore.remove(id);
				};
			}
		};

		for (var i = 0; i < length; i++) {
			_this.helper.push();
		}
		return _this;
	}

	ArrayOf_createClass(ItemGroup, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    ids = _props.formStore.ids;

			if (Object(utils["g" /* isFunction */])(children)) return children(ids, this.helper);
			return external_React_["Children"].map(children, function (child, index) {
				return Object(external_React_["cloneElement"])(child, { name: ids[index] });
			});
		}
	}]);

	return ItemGroup;
}(external_React_["Component"]), ArrayOf_class2.propTypes = {
	formStore: prop_types_default.a.object.isRequired,
	children: childrenType,
	name: prop_types_default.a.string.isRequired
}, ArrayOf_temp)) || ArrayOf_class) || ArrayOf_class);

var ArrayOf_ArrayOf = Object(external_mobxReact_["observer"])(_class3 = (ArrayOf_temp2 = _class4 = function (_Component2) {
	ArrayOf_inherits(ArrayOf, _Component2);

	function ArrayOf(props) {
		ArrayOf_classCallCheck(this, ArrayOf);

		var _this2 = ArrayOf_possibleConstructorReturn(this, (ArrayOf.__proto__ || Object.getPrototypeOf(ArrayOf)).call(this, props));

		_this2.forwardedProps = {
			name: _this2.props.name
		};

		var children = props.children,
		    forwardedProps = ArrayOf_objectWithoutProperties(props, ['children']);

		_this2.forwardedProps = forwardedProps;
		return _this2;
	}

	ArrayOf_createClass(ArrayOf, [{
		key: 'getValue',
		value: function getValue() {
			return this.demon.getValue();
		}
	}, {
		key: 'setValue',
		value: function setValue(value) {
			this.demon.setValue(value);
		}
	}, {
		key: 'getPristineValue',
		value: function getPristineValue() {
			return this.demon.getPristineValue();
		}
	}, {
		key: 'setPristineValue',
		value: function setPristineValue(value) {
			this.demon.setPristineValue(value);
		}
	}, {
		key: 'getValidState',
		value: function getValidState() {
			return this.demon.getValidState();
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var _props2 = this.props,
			    children = _props2.children,
			    name = _props2.name;

			return external_React_default.a.createElement(
				Demon_Demon,
				{
					forwardedProps: this.forwardedProps,
					isObject: true,
					isArray: true,
					ref: function ref(demon) {
						return _this3.demon = demon;
					}
				},
				function () {
					return external_React_default.a.createElement(
						ArrayOf_ItemGroup,
						{ name: name },
						children
					);
				}
			);
		}
	}]);

	return ArrayOf;
}(external_React_["Component"]), _class4.propTypes = {
	children: childrenType,
	name: prop_types_default.a.string.isRequired
}, ArrayOf_temp2)) || _class3;


// CONCATENATED MODULE: ./src/Input.js
var Input_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var Input_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function Input_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function Input_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function Input_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }




var Input_Input = function (_Component) {
	Input_inherits(Input, _Component);

	function Input() {
		Input_classCallCheck(this, Input);

		return Input_possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).apply(this, arguments));
	}

	Input_createClass(Input, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			return external_React_default.a.createElement(
				Demon_Demon,
				{ forwardedProps: this.props },
				function (props) {
					return external_React_default.a.createElement('input', Input_extends({}, props, { ref: function ref(node) {
							return _this2.node = node;
						} }));
				}
			);
		}
	}]);

	return Input;
}(external_React_["Component"]);


// CONCATENATED MODULE: ./src/Checkbox.js
var Checkbox_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var Checkbox_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function Checkbox_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function Checkbox_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function Checkbox_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }




var Checkbox_Checkbox = function (_Component) {
	Checkbox_inherits(Checkbox, _Component);

	function Checkbox() {
		Checkbox_classCallCheck(this, Checkbox);

		return Checkbox_possibleConstructorReturn(this, (Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).apply(this, arguments));
	}

	Checkbox_createClass(Checkbox, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			return external_React_default.a.createElement(
				Demon_Demon,
				{ forwardedProps: this.props, checkable: true },
				function (props) {
					return external_React_default.a.createElement('input', Checkbox_extends({}, props, {
						type: 'checkbox',
						ref: function ref(node) {
							return _this2.node = node;
						}
					}));
				}
			);
		}
	}]);

	return Checkbox;
}(external_React_["Component"]);


// CONCATENATED MODULE: ./src/Radio.js
var Radio_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var Radio_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function Radio_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function Radio_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function Radio_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }




var Radio_Radio = function (_Component) {
	Radio_inherits(Radio, _Component);

	function Radio() {
		Radio_classCallCheck(this, Radio);

		return Radio_possibleConstructorReturn(this, (Radio.__proto__ || Object.getPrototypeOf(Radio)).apply(this, arguments));
	}

	Radio_createClass(Radio, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			return external_React_default.a.createElement(
				Demon_Demon,
				{ forwardedProps: this.props, checkable: true, isRadio: true },
				function (props) {
					return external_React_default.a.createElement('input', Radio_extends({}, props, { type: 'radio', ref: function ref(node) {
							return _this2.node = node;
						} }));
				}
			);
		}
	}]);

	return Radio;
}(external_React_["Component"]);


// CONCATENATED MODULE: ./src/Select.js
var Select_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var Select_createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function Select_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function Select_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function Select_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }




var Select_Select = function (_Component) {
	Select_inherits(Select, _Component);

	function Select() {
		Select_classCallCheck(this, Select);

		return Select_possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).apply(this, arguments));
	}

	Select_createClass(Select, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.demon.setValue(this.node.value);
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			return external_React_default.a.createElement(
				Demon_Demon,
				{ forwardedProps: this.props, ref: function ref(demon) {
						return _this2.demon = demon;
					} },
				function (props) {
					return external_React_default.a.createElement('select', Select_extends({}, props, { ref: function ref(node) {
							return _this2.node = node;
						} }));
				}
			);
		}
	}]);

	return Select;
}(external_React_["Component"]);


// CONCATENATED MODULE: ./src/Option.js
/* harmony default export */ var Option = ('option');
// CONCATENATED MODULE: ./src/index.js
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "Demon", function() { return Demon_Demon; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "DemonButton", function() { return DemonButton_DemonButton; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "Form", function() { return Form_Form; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "Submit", function() { return Submit_Submit; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "Reset", function() { return Reset_Reset; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "Clear", function() { return Clear_Clear; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "ObjectOf", function() { return ObjectOf_ObjectOf; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "ArrayOf", function() { return ArrayOf_ArrayOf; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "Input", function() { return Input_Input; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "Checkbox", function() { return Checkbox_Checkbox; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "Radio", function() { return Radio_Radio; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "Select", function() { return Select_Select; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "Option", function() { return Option; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "formatHelper", function() { return FormatTypes["c" /* formatHelper */]; });





























/***/ }),
/* 11 */
/***/ (function(module, exports) {

// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };


/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */

function makeEmptyFunction(arg) {
  return function () {
    return arg;
  };
}

/**
 * This function accepts and discards inputs; it has no side effects. This is
 * primarily useful idiomatically for overridable function endpoints which
 * always need to be callable, since JS lacks a null-call idiom ala Cocoa.
 */
var emptyFunction = function emptyFunction() {};

emptyFunction.thatReturns = makeEmptyFunction;
emptyFunction.thatReturnsFalse = makeEmptyFunction(false);
emptyFunction.thatReturnsTrue = makeEmptyFunction(true);
emptyFunction.thatReturnsNull = makeEmptyFunction(null);
emptyFunction.thatReturnsThis = function () {
  return this;
};
emptyFunction.thatReturnsArgument = function (arg) {
  return arg;
};

module.exports = emptyFunction;

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */



var emptyFunction = __webpack_require__(12);

/**
 * Similar to invariant but only logs a warning if the condition is not met.
 * This can be used to log issues in development environments in critical
 * paths. Removing the logging code for production environments will keep the
 * same logic and follow the same code paths.
 */

var warning = emptyFunction;

if (false) { var printWarning; }

module.exports = warning;

/***/ }),
/* 14 */
/***/ (function(module, exports) {

var g;

// This works in non-strict mode
g = (function() {
	return this;
})();

try {
	// This works if eval is allowed (see CSP)
	g = g || Function("return this")() || (1, eval)("this");
} catch (e) {
	// This works if the window reference is available
	if (typeof window === "object") g = window;
}

// g can still be undefined, but nothing to do about it...
// We return undefined, instead of nothing here, so it's
// easier to handle this case. if(!global) { ...}

module.exports = g;


/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global) {// @flow


var key = '__global_unique_id__';

module.exports = function() {
  return global[key] = (global[key] || 0) + 1;
};

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(14)))

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(0);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _gud = __webpack_require__(15);

var _gud2 = _interopRequireDefault(_gud);

var _warning = __webpack_require__(13);

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MAX_SIGNED_31_BIT_INT = 1073741823;

// Inlined Object.is polyfill.
// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
function objectIs(x, y) {
  if (x === y) {
    return x !== 0 || 1 / x === 1 / y;
  } else {
    return x !== x && y !== y;
  }
}

function createEventEmitter(value) {
  var handlers = [];
  return {
    on: function on(handler) {
      handlers.push(handler);
    },
    off: function off(handler) {
      handlers = handlers.filter(function (h) {
        return h !== handler;
      });
    },
    get: function get() {
      return value;
    },
    set: function set(newValue, changedBits) {
      value = newValue;
      handlers.forEach(function (handler) {
        return handler(value, changedBits);
      });
    }
  };
}

function onlyChild(children) {
  return Array.isArray(children) ? children[0] : children;
}

function createReactContext(defaultValue, calculateChangedBits) {
  var _Provider$childContex, _Consumer$contextType;

  var contextProp = '__create-react-context-' + (0, _gud2.default)() + '__';

  var Provider = function (_Component) {
    _inherits(Provider, _Component);

    function Provider() {
      var _temp, _this, _ret;

      _classCallCheck(this, Provider);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.emitter = createEventEmitter(_this.props.value), _temp), _possibleConstructorReturn(_this, _ret);
    }

    Provider.prototype.getChildContext = function getChildContext() {
      var _ref;

      return _ref = {}, _ref[contextProp] = this.emitter, _ref;
    };

    Provider.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
      if (this.props.value !== nextProps.value) {
        var oldValue = this.props.value;
        var newValue = nextProps.value;
        var changedBits = void 0;

        if (objectIs(oldValue, newValue)) {
          changedBits = 0; // No change
        } else {
          changedBits = typeof calculateChangedBits === 'function' ? calculateChangedBits(oldValue, newValue) : MAX_SIGNED_31_BIT_INT;
          if (false) {}

          changedBits |= 0;

          if (changedBits !== 0) {
            this.emitter.set(nextProps.value, changedBits);
          }
        }
      }
    };

    Provider.prototype.render = function render() {
      return this.props.children;
    };

    return Provider;
  }(_react.Component);

  Provider.childContextTypes = (_Provider$childContex = {}, _Provider$childContex[contextProp] = _propTypes2.default.object.isRequired, _Provider$childContex);

  var Consumer = function (_Component2) {
    _inherits(Consumer, _Component2);

    function Consumer() {
      var _temp2, _this2, _ret2;

      _classCallCheck(this, Consumer);

      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return _ret2 = (_temp2 = (_this2 = _possibleConstructorReturn(this, _Component2.call.apply(_Component2, [this].concat(args))), _this2), _this2.state = {
        value: _this2.getValue()
      }, _this2.onUpdate = function (newValue, changedBits) {
        var observedBits = _this2.observedBits | 0;
        if ((observedBits & changedBits) !== 0) {
          _this2.setState({ value: _this2.getValue() });
        }
      }, _temp2), _possibleConstructorReturn(_this2, _ret2);
    }

    Consumer.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
      var observedBits = nextProps.observedBits;

      this.observedBits = observedBits === undefined || observedBits === null ? MAX_SIGNED_31_BIT_INT // Subscribe to all changes by default
      : observedBits;
    };

    Consumer.prototype.componentDidMount = function componentDidMount() {
      if (this.context[contextProp]) {
        this.context[contextProp].on(this.onUpdate);
      }
      var observedBits = this.props.observedBits;

      this.observedBits = observedBits === undefined || observedBits === null ? MAX_SIGNED_31_BIT_INT // Subscribe to all changes by default
      : observedBits;
    };

    Consumer.prototype.componentWillUnmount = function componentWillUnmount() {
      if (this.context[contextProp]) {
        this.context[contextProp].off(this.onUpdate);
      }
    };

    Consumer.prototype.getValue = function getValue() {
      if (this.context[contextProp]) {
        return this.context[contextProp].get();
      } else {
        return defaultValue;
      }
    };

    Consumer.prototype.render = function render() {
      return onlyChild(this.props.children)(this.state.value);
    };

    return Consumer;
  }(_react.Component);

  Consumer.contextTypes = (_Consumer$contextType = {}, _Consumer$contextType[contextProp] = _propTypes2.default.object, _Consumer$contextType);


  return {
    Provider: Provider,
    Consumer: Consumer
  };
}

exports.default = createReactContext;
module.exports = exports['default'];

/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright 2013-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */



var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

module.exports = ReactPropTypesSecret;


/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 */



/**
 * Use invariant() to assert state which your program assumes to be true.
 *
 * Provide sprintf-style format (only %s is supported) and arguments
 * to provide information about what broke and what you were
 * expecting.
 *
 * The invariant message will be stripped in production, but the invariant
 * will remain to ensure logic does not differ in production.
 */

var validateFormat = function validateFormat(format) {};

if (false) {}

function invariant(condition, format, a, b, c, d, e, f) {
  validateFormat(format);

  if (!condition) {
    var error;
    if (format === undefined) {
      error = new Error('Minified exception occurred; use the non-minified dev environment ' + 'for the full error message and additional helpful warnings.');
    } else {
      var args = [a, b, c, d, e, f];
      var argIndex = 0;
      error = new Error(format.replace(/%s/g, function () {
        return args[argIndex++];
      }));
      error.name = 'Invariant Violation';
    }

    error.framesToPop = 1; // we don't care about invariant's own frame
    throw error;
  }
}

module.exports = invariant;

/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Copyright (c) 2013-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * 
 */

function makeEmptyFunction(arg) {
  return function () {
    return arg;
  };
}

/**
 * This function accepts and discards inputs; it has no side effects. This is
 * primarily useful idiomatically for overridable function endpoints which
 * always need to be callable, since JS lacks a null-call idiom ala Cocoa.
 */
var emptyFunction = function emptyFunction() {};

emptyFunction.thatReturns = makeEmptyFunction;
emptyFunction.thatReturnsFalse = makeEmptyFunction(false);
emptyFunction.thatReturnsTrue = makeEmptyFunction(true);
emptyFunction.thatReturnsNull = makeEmptyFunction(null);
emptyFunction.thatReturnsThis = function () {
  return this;
};
emptyFunction.thatReturnsArgument = function (arg) {
  return arg;
};

module.exports = emptyFunction;

/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright 2013-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */



var emptyFunction = __webpack_require__(19);
var invariant = __webpack_require__(18);
var ReactPropTypesSecret = __webpack_require__(17);

module.exports = function() {
  function shim(props, propName, componentName, location, propFullName, secret) {
    if (secret === ReactPropTypesSecret) {
      // It is still safe when called from React.
      return;
    }
    invariant(
      false,
      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
      'Use PropTypes.checkPropTypes() to call them. ' +
      'Read more at http://fb.me/use-check-prop-types'
    );
  };
  shim.isRequired = shim;
  function getShim() {
    return shim;
  };
  // Important!
  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
  var ReactPropTypes = {
    array: shim,
    bool: shim,
    func: shim,
    number: shim,
    object: shim,
    string: shim,
    symbol: shim,

    any: shim,
    arrayOf: getShim,
    element: shim,
    instanceOf: getShim,
    node: shim,
    objectOf: getShim,
    oneOf: getShim,
    oneOfType: getShim,
    shape: getShim
  };

  ReactPropTypes.checkPropTypes = emptyFunction;
  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};


/***/ })
/******/ ]);
});
//# sourceMappingURL=react-form-mobx.js.map