'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Demon = require('./Demon');

var _Demon2 = _interopRequireDefault(_Demon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ObjectOf = (_temp = _class = function (_Component) {
	_inherits(ObjectOf, _Component);

	function ObjectOf(props) {
		_classCallCheck(this, ObjectOf);

		var _this = _possibleConstructorReturn(this, (ObjectOf.__proto__ || Object.getPrototypeOf(ObjectOf)).call(this, props));

		var children = props.children,
		    forwardedProps = _objectWithoutProperties(props, ['children']);

		_this.forwardedProps = forwardedProps;
		return _this;
	}

	_createClass(ObjectOf, [{
		key: 'getValue',
		value: function getValue() {
			return this.demon.getValue();
		}
	}, {
		key: 'setValue',
		value: function setValue(value) {
			this.demon.setValue(value);
		}
	}, {
		key: 'getPristineValue',
		value: function getPristineValue() {
			return this.demon.getPristineValue();
		}
	}, {
		key: 'setPristineValue',
		value: function setPristineValue(value) {
			this.demon.setPristineValue(value);
		}
	}, {
		key: 'getValidState',
		value: function getValidState() {
			return this.demon.getValidState();
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var children = this.props.children;

			return _react2.default.createElement(
				_Demon2.default,
				{
					forwardedProps: this.forwardedProps,
					isObject: true,
					ref: function ref(demon) {
						return _this2.demon = demon;
					}
				},
				function () {
					return children;
				}
			);
		}
	}]);

	return ObjectOf;
}(_react.Component), _class.propTypes = {
	children: _propTypes2.default.node,
	name: _propTypes2.default.string.isRequired
}, _temp);
exports.default = ObjectOf;